<!DOCTYPE html>
<html>
<head>
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="mobile-web-app-capable" content="yes">

    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0, user-scalable=no">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
    <meta charset="UTF-8">
    <title class="browserTitle"></title>

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/css/bootstrap.min.css" integrity="sha384-QWTKZyjpPEjISv5WaRU9OFeRpok6YctnYmDr5pNlyT2bRjXh0JMhjY6hW+ALEwIH" crossorigin="anonymous">

    <!-- Boostrap Icons -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.3/font/bootstrap-icons.css">

    <!-- Optional theme -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=PT+Sans">
    <link rel="stylesheet" type="text/css" href="css/layout.css">

    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.2/css/dataTables.bootstrap5.min.css">

    <!-- Popper (necessary for Bootstrap's tooltips) -->
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.11.8/dist/umd/popper.min.js" integrity="sha384-I7E8VVD/ismYTF4hNIPjVp/Zjvgyol6VFvRkX/vR+Vc4jQkC+hVqc2pM8ODewa9r" crossorigin="anonymous"></script>
    <!-- Latest compiled and minified JavaScript -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.min.js"
integrity="sha384-0pUGZvbkm6XF6gxjEnlmuGrJXVbNuzT9qBBavbLwCsOGabYfZo0T0to5eqruptLy" crossorigin="anonymous"></script>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/lodash.js/4.17.21/lodash.min.js" integrity="sha512-WFN04846sdKMIP5LKNphMaWzU7YpMyCU245etK3g/2ARYbPK9Ub18eG+ljU96qKRCWh+quCY7yefSmlkQw1ANQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/2.0.0/clipboard.min.js"></script>

    <!-- jQuery (necessary for DataTables -->
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.6.4/dist/jquery.min.js"></script>
    <!-- DataTables -->
    <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.4/js/dataTables.bootstrap5.min.js"></script>

    <script type="text/javascript" src="js/fapi.ui.js"></script>
</head>

<body>

    <div class="pageHeader container-fluid">
        <div class="row">
            <div class="col-md-8">
                <a href="index.html"><img id="logo" src=''></a>
            </div>
            <div id="userInfoHolder" class="col-md-4"></div>
            <div id="csvButtonHolder" class="col-md-12"></div>
        </div>
    </div>
    <div class="clearfix"></div>

    <!-- resident DOM -->
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">

                <table id="logsListing" class="table table-striped table-bordered table-hover">
                    <thead>
                    </thead>

                    <tbody>
                    </tbody>
                </table>

            </div>
        </div>
    </div>


    <!-- error modal -->
    <div class="modal" id="errorModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="errorLabel">Error</h4>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    Error: <span id="errorMessage"></span>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-sm btn-light bg-gradient border border-secondary" data-bs-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>

    <!-- loading modal -->
    <div class="modal" id="loadingModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel" data-bs-backdrop="static" data-bs-keyboard="false">
        <div class="modal-dialog modal-sm" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="loadingLabel">Loading...</h4>
                </div>
                <div class="modal-body">
                    <div class="text-center">
                        <img src="/images/spinner.gif" width="100px" height="30px" />
                    </div>
                    <div>
                        <span id="loadingMessage"></span>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Config modal popup -->
    <div class="modal" id="configModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel">
        <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title">
                        <button class="btn-clipboard btn btn-sm" data-clipboard-target="#config" alt="Copy config to clipboard" title="Copy config to clipboard"><span class="bi bi-box-arrow-in-right"></span></button>
                        Configuration for <code id="configTestId" class="text-muted"></code>
                    </h4>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <div class="wrapLongStrings">
                        <pre id="config" class="row-bg-light p-1"></pre>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-sm btn-light bg-gradient border border-secondary" data-bs-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>


    <script>
        /**
         *
         */
        document.addEventListener("DOMContentLoaded", () => {
            var urlParams = new URLSearchParams(window.location.search);
            var public = Boolean(urlParams.get('public'));

            FAPI_UI.showBusy();
            FAPI_UI.loadLogListTemplates()
            .then(function() {
                return FAPI_UI.getUserInfo();
            }).then(function (){
                return FAPI_UI.getCsvDigestButton();
            }).then(function (){
                return loadServerInfo();
            }).then(function() {
                return loadAvailableLogs(public);
            }).finally(function() {
                FAPI_UI.hideBusy();
            });

            var clipboard = new ClipboardJS('.btn-clipboard');
            clipboard.on('success', function(e) {
                console.log(e);
            });
            clipboard.on('error', function(e) {
                console.log(e);
            });
        });

    function loadServerInfo() {
        return fetch('/api/server')
            .then((response) => response.json())
            .then((data) => {
                const browserTitle = document.querySelector('.browserTitle');
                browserTitle.textContent = `${data.brand} Functional Conformance: Login`;

                const serverInfo = document.querySelector('.serverInfo');
                const textStr = [(data.hasOwnProperty("external_ip") ? "External IP: " + data.external_ip:""), (data.hasOwnProperty("version") ? "Version: " +data.version:"")].filter(Boolean).join(" - ");
                serverInfo.textContent = textStr;

                const brandDesc = document.querySelector('.brandDesc');
                brandDesc.textContent = `${data.brand} Functional Conformance Suite - Brought to you by Raidiam, with thanks to the OpenID Foundation`;

                const logo = document.querySelector('#logo');
                logo.src = `/images/${data.logo}`;
            });
    }

        /**
         *
         */

        /**
         *
         */
        function loadAvailableLogs(public) {
            return $('#logsListing').DataTable({
                    serverSide: true,
                    ajax: {
                        url: '/api/log' + (public ? '?public=true' : ''),
                        cache: true,
                        data: function(data) {
                            // Translate query parameters into a simpler schema
                            return {
                                draw: data.draw,
                                start: data.start,
                                length: data.length,
                                search: data.search.value,
                                order: _.map(data.order, function(x) {
                                    return data.columns[x.column].data + ',' + x.dir;
                                }).join(',')
                            };
                        },
                        error: function(jqxhr, status, error) {
                            FAPI_UI.showError(jqxhr.responseJSON ? jqxhr.responseJSON : {
                                code: jqxhr.status,
                                error: error
                            });
                        }
                    },
                    columns: [
                        {
                            title: 'Instance ID',
                            data: 'testId',
                            render: {
                                display: function(data) { return FAPI_UI.logTemplates.LOG_DETAIL({ id: data, public: public }); }
                            }
                        },
                        {
                            title: 'Config',
                            data: null,
                            render: {
                                display: function() { return FAPI_UI.logTemplates.CONFIG(); }
                            },
                            createdCell: function(cell) { $(cell).addClass('configColumn'); },
                            orderable: false,
                            visible: !public
                        },
                        {
                            title: 'Name',
                            data: 'testName',
                            render: $('#logsListing').DataTable.render.text()
                        },
                        {
                            title: 'Variant',
                            data: 'variant',
                            defaultContent: '',
                            render: {
                                display: function(v) { return FAPI_UI.formatVariant(v); }
                            }
                        },
                        {
                            title: 'Description',
                            data: 'description',
                            render: $('#logsListing').DataTable.render.text(),
                            defaultContent: ''
                        },
                        {
                            title: 'Started',
                            data: 'started',
                            render: {
                                display: function(data) { return FAPI_UI.logTemplates.DATE({ date: data }); }
                            }
                        },
                        {
                            title: 'Plan ID',
                            data: 'planId',
                            defaultContent: '',
                            render: {
                                display: function(data) {
                                    if (data)
                                        return FAPI_UI.logTemplates.PLAN_DETAIL({ id: data, public: public });
                                    else
                                        return '';
                                }
                            }
                        },
                        {
                            title: 'Status',
                            data: 'status',
                        defaultContent: '',
                        createdCell: function(cell, cellData) {
                            $(cell).addClass('testStatusResultBlock testStatus-' + (cellData ? cellData.toLowerCase() : 'testStatus-unknown'));
                        }
                        },
                        {
                            title: 'Result',
                            data: 'result',
                        defaultContent: '',
                        createdCell: function(cell, cellData) {
                            $(cell).addClass('testStatusResultBlock testResult-' + (cellData ? cellData.toLowerCase() : 'testResult-unknown'));
                        }
                        },
                        {
                            title: 'Owner',
                            data: function(row) { return { owner: row.owner ? row.owner : {} }; },
                            render: {
                                display: function(data) { return FAPI_UI.logTemplates.OWNER(data); }
                            },
                            visible: !public && FAPI_UI.currentUser && FAPI_UI.currentUser.isAdmin
                        }
                    ],
                    createdRow: function(row, data) {
                        // wire up configuration button
                        $('.showConfigBtn', row).click(function(evt) {
                            evt.preventDefault();
                        $('#config').html(_.escape(JSON.stringify(data.config, null, 4)));
                                $('#configTestId').html(_.escape(data.testId));

                                var myModalEl = document.getElementById('configModal');
                                var modal     = bootstrap.Modal.getOrCreateInstance(myModalEl);
                                modal.show();
                            });
                    },
                    order: [[5, "desc"]] // sort by the "date" column, descending, by default
            });
        }
    </script>

    <footer class="pageFooter">
    <div class="row">
        <span class="muted"><div class="brandDesc"></div><br /></span>
        <span class="muted"></span><a href="https://raidiam.com"><img src="/images/raidiam.png" width="285" height="32"></a></span>
        <div class="serverInfo"></div>
    </div>
    </footer>

</body>

</html>
